%=======================================================================
%To solve optimization problem:
%Create a new subfolder in ...\PSG\MATLAB:
%..\PSG\MATLAB\problem_hull_meansquare
%Download and unpack the following zipped file from 'Data' to the created folder:
%'Mat_data_problem_hull_meansquare.zip'
%Run program 'problem_hull_meansquare.m'
%=======================================================================

clc;
clear;
addpath('..');

%Load data:
load('.\problem_hull_meansquare_data.mat')
%Define options for PSG solver:
stroptions.Precision = 9;
%Define input arguments:
string = {'meansquare',0.0189,'meansquare'};
w = {[],[]};

%Solve optimization problems:
[xout, fval, status, output] = riskprog(string, [], H, [], [], [], [], [], Aeq, beq, lb, ub, [], stroptions);
 
%Display results:
disp(' ');
disp('Results: ');
%Display status of optimization problem:
disp(sprintf('status of optimization problem = %s', status));
%Display solving time:
disp(sprintf('solving time = %g', output.solving_time));
%Display objective:
disp(sprintf('objective = %g', fval));
%Display function:
disp(sprintf('meansquare= %g', output.frval(1)));
disp(sprintf('meansquare= %g', output.frval(2)));
%Display left hand sides of linear equality:
disp(sprintf('linear equality = %g', output.fAeqval));
%Display residual of linear equality:
disp(sprintf('residual of linear equality = %g', output.rAeqval));
%Display optimal point:
disp('optimal point = ');
disp(xout');
